//Javascript for walkthrough in 3d-pdf.
//v1.0 in 2013.05.25.
//By TAK2HATA.
//General Declaimer.
//I MAKES NO GUARANTEE OF VALIDITY about  this script.
//Please use this script at your own risk.
//You can use freely. 

function main()
{
	//var vspeed = 1.0;//default walkspeed
	var ls = 1.0;//default lightscale
	//---------keymap
	//indexOf
	var keySPEEDUP = 30;//arrow-up30
	var keySPEEDDOWN = 31;//arrow-down31
	var keyUP = 99;//num-1-48
	var keyDOWN = 32;//num-0-49
	var keyLIGHTUP = 29;//arrow-right-29
	var keyLIGHTDOWN = 28;//arrow-left-28
	
	var keyFORWARD = 119;//num-8-56
	var keyMarkFORWARD = 109;//"2"num-8-56
	var keyBACKWARD = 115;//num-2-50
	var keyRIGHTWARD = 100;//num-6-54
	var keyLEFTWARD = 97;//num-4-52
	var keyTURNRIGHT = 101;//num-9-57
	var keyTURNLEFT = 113;//num-7-55
	var keyZOOMUP = 120;//z(small)-122
	var keyZOOMDOWN = 122;//x(small)-120
	
	var keyFlipClip = 53;//5
	var keyClipOff = 48;//0
	var keyClipDown = 50;//2
	var keyClipUp = 56;//8
	var keyClipFront = 55;//7
	var keyClipBack = 51;//3
	var keyClipLeft = 52;//4
	var keyClipRight = 54;//6
	var keyClipTurn = 49;//1
	var keyClipTurnInv = 57;//9

	//var bgColorA = new Color( 0.5, 0.6, 0.9 );
	//var bgColorB = new Color( 1.0, 1.0, 1.0 );
	//--------------keymap end
	var generalkeyEventHandler = new KeyEventHandler();
	generalkeyEventHandler.onEvent = function( event )
	{
		//curcor keys
		if ( event.characterCode == keyClipTurn ){
			clipRot = clipRot + Math.PI / 36;
			updateclip();
		}
		if ( event.characterCode == keyClipTurnInv ){
			clipRot = clipRot - Math.PI / 36;
			updateclip();
		}
		if ( event.characterCode == keyFlipClip ){
			toggleflipclip();
			updateclip();
		}
		if ( event.characterCode == keyClipUp ){
			clipRot = 0;
			clipZdepth = clipZdepth + vspeed;
			clipDir = "Z";
			updateclip();
		}
		if ( event.characterCode == keyClipDown ){
			clipRot = 0;
			clipZdepth = clipZdepth - vspeed;
			clipDir = "Z";
			updateclip();
		}
		if ( event.characterCode == keyClipLeft ){
			clipRot = 0;
			clipYdepth = clipYdepth + vspeed;
			clipDir = "Y";
			updateclip();
		}
		if ( event.characterCode == keyClipRight ){
			clipRot = 0;
			clipYdepth = clipYdepth - vspeed;
			clipDir = "Y";
			updateclip();
		}
		if ( event.characterCode == keyClipFront ){
			clipRot = 0;
			clipXdepth = clipXdepth + vspeed;
			clipDir = "X";
			updateclip();
		}
		if ( event.characterCode == keyClipBack ){
			clipRot = 0;
			clipXdepth = clipXdepth - vspeed;
			clipDir = "X";
			updateclip();
		}
		if ( event.characterCode == keyClipOff ){
			clippoff();
		}
		if ( event.characterCode == keySPEEDUP ){
			vspeed = vspeed + dsp;
			speeddisplay(vspeed)
		}
		if( event.characterCode == keySPEEDDOWN ){
			vspeed = vspeed - dsp;
			if( vspeed < dsp ){
				vspeed = dsp;
			}
			speeddisplay(vspeed)
		}
		if( event.characterCode == keyLIGHTUP ){
			ls = scene.lightScaleFactor;
			scene.lightScaleFactor = ls + 0.5;
		}
		if( event.characterCode == keyLIGHTDOWN ){
			ls = scene.lightScaleFactor -0.5;
			//if( ls < 0.5 ) {
			//ls = 0.5;
			//}
			scene.lightScaleFactor = ls;
		}
		//curcor keys end
		//"0"key
		if( event.characterCode == keyUP ){
			viewupward( -vspeed );
		}
		//"1"key
		if( event.characterCode == keyDOWN ){
			viewupward(vspeed);
		}

		if ( event.characterCode == keyFORWARD || event.characterCode == ( keyFORWARD - 32 )){
			viewforward(vspeed);
		}
		if( event.characterCode == keyBACKWARD || event.characterCode == ( keyBACKWARD - 32 ) ){
			viewforward( -vspeed);
		}
		//"4"key
		if( event.characterCode == keyLEFTWARD || event.characterCode == ( keyLEFTWARD - 32 ) ){
			viewleftward(vspeed);
		}
		//"6"key
		if( event.characterCode == keyRIGHTWARD || event.characterCode == ( keyRIGHTWARD - 32 ) ){
			viewleftward(-vspeed);
		}
		//"7"key
		if( event.characterCode == keyTURNLEFT || event.characterCode == ( keyTURNLEFT - 32 ) ){
			//viewforward(vspeed);
			viewleftturn( 2);
		}
		//"9"key
		if( event.characterCode == keyTURNRIGHT || event.characterCode == ( keyTURNRIGHT - 32 ) ){
			//viewforward(vspeed);
			viewleftturn( -2);
		}
		//"z"key
		if( event.characterCode == keyZOOMUP ){
			camerazoom( -15 );
		}
		//"x"key
		if( event.characterCode == keyZOOMDOWN ){
			camerazoom( 15 );
		}
		//DrawCameraPos;
		//event.canvas.background.setColor( bgColorA , bgColorB )
	}
	runtime.addEventHandler( generalkeyEventHandler );

	var chkClick = false;
	var dmarker1 = scene.createSquareMesh( dsp * 2 , dsp * 2 ,"mark1");
	var dmarker2 = scene.createSquareMesh( dsp * 2 , dsp * 2 ,"mark2");
	var pt1 = new Vector3( 0,0,0 );
	var pt2 = new Vector3( 0,0,0 );
	var pt3 = new Vector3( 0,0,0 );
	var pt4 = new Vector3( 0,0,0 );

	myMouseHandler= new MouseEventHandler();
	myMouseHandler.onMouseHit = true;
	myMouseHandler.onEvent= function( event )
	{
		if( event.ctrlKeyDown == true ){
			if ( chkClick == false ){
				pt11 = pt1;
				pt1 = event.hits[0].position;
				runtime.removeCustomToolButton( "admesA" );
				runtime.removeCustomToolButton( "admesB" );
				runtime.addCustomToolButton( "admesA", "input second point" , "push button");
				runtime.addCustomToolButton( "admesB", "dz=", "push button");
				chkClick =true;
				dmarker1.transform.translateInPlace( pt1.subtract( pt11 ) );
			}
			else{
				pt22 = pt2;
				pt2 = event.hits[0].position;
				vec = pt1.subtract( pt2 );
				runtime.removeCustomToolButton( "admesA" );
				runtime.removeCustomToolButton( "admesB" );
				runtime.addCustomToolButton( "admesA", "dist = " + ( Math.round( vec.length * 1000 ) / 1000) + " m" , "push button");
				runtime.addCustomToolButton( "admesB", "dz= " + ( Math.round( vec.z  * 1000 ) / 1000) + " m" , "push button");
				chkClick = false;
				dmarker2.transform.translateInPlace( pt2.subtract( pt22 ) );
			}
		}
		if( event.shiftKeyDown == true ){
			var camera              = scene.cameras.getByIndex( 0 );
			var divnum = 30;
			pt3 = event.hits[0].position;
			pt4 = pt3.subtract( camera.position );
			pt4.addInPlace( Vector3( 0,0,1.5 ) );
			//pt4.scaleInPlace( 1 / divnum );
			//for( i=1; i<divnum; i++ ){
				camera.position.addInPlace( pt4 );
				camera.targetPosition.addInPlace( pt4 );
				camera.roll = 0;
				scene.update;
			//	runtime.refresh;
			//}
		}
	}
	runtime.addEventHandler( myMouseHandler );

}

function toggleflipclip()
{
	if ( chkflip  == false ){
		chkflip  = true;
	}
	else{
		chkflip  = false;
	}
}

function updateclip()
{
		var m1 = new Matrix4x4(); 
		var cp = scene.createClippingPlane();
	if( clipDir == "X" ){
		m1.translateInPlace( Vector3( dcXdepth,dcYdepth,dcZdepth ) );
		if ( chkflip == true ){
			m1.rotateAboutXInPlace( Math.PI );
		}
		m1.rotateAboutYInPlace( Math.PI / 2 );
		m1.rotateAboutZInPlace( clipRot );
		m1.translateInPlace( Vector3( clipXdepth,dctarget.y,dctarget.z ) );
	}
	if( clipDir == "Y" ){
		m1.translateInPlace( Vector3( dcXdepth,dcYdepth,dcZdepth ) );
		if ( chkflip == true ){
			m1.rotateAboutXInPlace( Math.PI );
		}
		m1.rotateAboutXInPlace( Math.PI / 2 );
		m1.rotateAboutZInPlace( clipRot );
		m1.translateInPlace( Vector3( dctarget.x,clipYdepth,dctarget.z ) );
	}
	if( clipDir == "Z" ){
		m1.translateInPlace( Vector3( dcXdepth,dcYdepth,dcZdepth ) );
		if ( chkflip == true ){
			m1.rotateAboutXInPlace( Math.PI );
		}
		m1.rotateAboutXInPlace( clipRot );
		m1.translateInPlace( Vector3( dctarget.x,dctarget.y,clipZdepth ) );
	}
		cp.transform.multiplyInPlace( m1 );
		cp.renderMode = cliprender;
		scene.update;
}

function clippoff()
{
	var m1 = new Matrix4x4(); 
	var cp = scene.createClippingPlane();
	m1.translateInPlace( Vector3( 0,0,20 ) );
	m1.rotateAboutYInPlace( Math.PI );
	cp.transform.multiplyInPlace( m1 );
	cp.clippingPlane.remove();
}
function RedrawCameraPos()
{
	var mainsc              = sceneObjectList.getByName( "main" );
	var navisc              = sceneObjectList.getByName( "navigation" );
	var maincamera          = mainsc.cameras.getByIndex( 0 );
	var cammesh = navisc.Meshes.GetByName( "campos" );
	cammesh.remove;
}
function DrawCameraPos()
{
	var mainsc              = sceneObjectList.getByName( "main" );
	var navisc              = sceneObjectList.getByName( "navigation" );
	var maincamera          = mainsc.cameras.getByIndex( 0 );
	console.print("test");
	var marker1 = navisc.createSquareMesh( 0.600,0.600,"campos");
	marker1.transform.translateInPlace( Vector3( camera.position ) );
	marker1.transform.translateInPlace( cameraDirection );
}

function camerazoom( va )
{
	var camera              = scene.cameras.getByIndex( 0 );
	var rad = camera.fov + (va /180) * Math.PI;
	if ( rad < ((20 /180) * Math.PI) ){
		rad = ((20 /180) * Math.PI);
	}
	if ( rad > ((150 /180) * Math.PI) ){
		rad = ((150 /180) * Math.PI);
	}
	camera.fov = rad;
	
	camera.roll = 0;
	scene.update;
}

function viewforward(vspeed)
{
	var camera              = scene.cameras.getByIndex( 0 );
    var cameraDistance 		= 0.0;
    var cameraDirection 	= new Vector3(); 
	var cameraVector = new Vector3( camera.position ); 
	cameraVector.subtractInPlace( camera.targetPosition );
	cameraDistance = cameraVector.length;
	cameraDirection.set( cameraVector ); 
	cameraDirection.scaleInPlace( vspeed / cameraDistance );
	cameraDirection.z = 0;
	camera.position.subtractInPlace( cameraDirection );
	camera.targetPosition.subtractInPlace( cameraDirection );
	camera.roll = 0;
//	camera.position.addScaledInPlace( cameraDirection, cameraDistance );
	scene.update;

}

function viewleftward(vspeed)
{
	var camera              = scene.cameras.getByIndex( 0 );
    var cameraDistance 		= 0.0;
    var cameraDirection 	= new Vector3(); 
	var cameraVector = new Vector3( camera.position ); 
	var dx = 0;
	var dy = 0;
	cameraVector.subtractInPlace( camera.targetPosition );
	cameraDistance = cameraVector.length;
	cameraDirection.set( cameraVector ); 
	cameraDirection.scaleInPlace( vspeed / cameraDistance );
	cameraDirection.z = 0;
	dx = cameraDirection.x;
	dy = cameraDirection.y;
	cameraDirection.x = -dy;
	cameraDirection.y = dx;
	camera.position.subtractInPlace( cameraDirection );
	camera.targetPosition.subtractInPlace( cameraDirection );
	camera.roll = 0;
//	camera.position.addScaledInPlace( cameraDirection, cameraDistance );
	scene.update;

}
function speeddisplay(vspeed){
	runtime.removeCustomToolButton( "admesC" );
	runtime.addCustomToolButton( "admesC", "speed= " + vspeed + " m" , "push button");
}

function viewleftturn(vspeed)
{
	var camera              = scene.cameras.getByIndex( 0 );
    var cameraDistance 		= 0.0;
    var cameraDirection 	= new Vector3(); 
	var cameraVector = new Vector3( camera.targetPosition ); 
	var dx = 0;
	var dy = 0;
	var dz = 0;
	var rad = 0;
	cameraVector.subtractInPlace( camera.position );
	cameraDirection.set( cameraVector ); 
	dz = cameraDirection.z;
	cameraDirection.z = 0;
	cameraDistance = cameraDirection.length;
	cameraDirection.scaleInPlace( 1 / cameraDistance );
//	cameraDirection.z = 0;
	dx = cameraDirection.x;
	dy = cameraDirection.y;
	rad = Math.atan2( dy , dx);
	rad = rad + ( vspeed / 180) * Math.PI;
	cameraDirection.x = Math.cos( rad );
	cameraDirection.y = Math.sin( rad );
	cameraDirection.scaleInPlace( cameraDistance );
	cameraDirection.z = dz;
	cameraDirection.addInPlace( camera.position );
	//camera.position.addInPlace( cameraDirection );
	camera.targetPosition.set( cameraDirection );
	camera.roll = 0;
//	camera.position.addScaledInPlace( cameraDirection, cameraDistance );
	scene.update;
}

function viewupward(vspeed)
{
	var camera              = scene.cameras.getByIndex( 0 );
    var cameraDirection 	= new Vector3(); 
	var cameraVector = new Vector3( camera.position ); 
	cameraDirection.x = 0;
	cameraDirection.y = 0;
	cameraDirection.z = vspeed;
	camera.position.addInPlace( cameraDirection );
	camera.targetPosition.addInPlace( cameraDirection );
	camera.roll = 0;
//	camera.position.addScaledInPlace( cameraDirection, cameraDistance );
	scene.update;

}

var tcam       = scene.cameras.getByIndex( 0 );
var dctarget = tcam.targetPosition;
var chkflip  = false;
var bb = scene.computeBoundingBox();
var dcXdepth = -bb.center.x;
var dcYdepth = -bb.center.y;
var dcZdepth = -bb.center.z;
var clipZdepth = bb.center.z;
var clipXdepth = bb.center.x;
var clipYdepth = bb.center.y;
//var clipZdepth = tcam.targetPosition.z;
//var clipXdepth = tcam.targetPosition.x;
//var clipYdepth = tcam.targetPosition.y;
var clipDir = "X";
var clipRot = 0;
var cliprender = "vertices";

//scene.gridMode = "wire";
//scene.showGrid = true;
var diag = bb.max.subtract(bb.min);
vspeed = ~~(diag.length / 100);
if( vspeed == 0){ vspeed = 0.1 ;}
dsp = vspeed / 10;

var reftex;
/*
for (var m=0; m < scene.materials.count ; m++){
	if( scene.materials.getByIndex(m) != undefined){
		var mname = scene.materials.getByIndex(m).name;
		//console.print( mname );
	}
}
*/
for (var m=0; m < scene.materials.count ; m++){
	if( scene.materials.getByIndex(m) != undefined){
		 if( scene.materials.getByIndex(m).name.search(/refmap/i) != -1 ){
			reftex = scene.materials.getByIndex(m).diffuseTexture.getImage();
		}
	}
}
var ref_exp = /refl(\d+)/i;
var emis_exp = /emis(\d+)/i;
var spec_exp = /spec(\d+)/i;
var exp_exp = /exp(\d+)/i;
for (var m=0; m < scene.materials.count ; m++){
	if( scene.materials.getByIndex(m) != undefined){
		var mname = scene.materials.getByIndex(m).name;
		var dfcl = scene.materials.getByIndex(m).diffuseColor;
		if( reftex != null ){
			var refvals = mname.match(ref_exp);
			if( refvals != null ){
				var refval = parseFloat( RegExp.$1 ) / 100;
				if( refval > 1 ){ refval = 1.0; }
				scene.materials.getByIndex(m).reflectionTexture.setImage(reftex);
				scene.materials.getByIndex(m).reflectionStrength = refval;
				scene.materials.getByIndex(m).ambientColor.set(0,0,0);
				//scene.materials.getByIndex(m).diffuseColor.set( dfcl.r * ( 1 - refval ) ,dfcl.g * ( 1 - refval ) ,dfcl.b * ( 1 - refval ) );
			}
		}
		var emisvals = mname.match(emis_exp);
		if( emisvals != null ){
			var emisval = parseFloat( RegExp.$1 ) / 100;
			//if( emisval > 1 ){ emisval = 1.0; }
			//scene.materials.getByIndex(m).emissiveColor.set( dfcl.r * emisval, dfcl.g * emisval, dfcl.b * emisval);
			scene.materials.getByIndex(m).emissiveColor.set( 1,1,1);
			scene.materials.getByIndex(m).ambientColor.set( 1,1,1);
			scene.materials.getByIndex(m).diffuseColor.set( 1,1,1);
		}
		
		var specvals = mname.match(spec_exp);
		if( specvals != null ){
			var specval = parseFloat( RegExp.$1 ) / 100;
			scene.materials.getByIndex(m).specularColor.set(dfcl);
			scene.materials.getByIndex(m).specularStrength = specval;
			//scene.materials.getByIndex(m).specularStrength = 1.0;
		}
		/*
		var expvals = mname.match(exp_exp);
		if( expvals != null ){
			var expval = parseFloat( RegExp.$1 ) / 100;
			scene.materials.getByIndex(m).phongExponent = expval;
		}
		*/

	}
}
runtime.reflesh;
runtime.addCustomToolButton( "admesA", "ctrl + click", "push button");
runtime.addCustomToolButton( "admesB", "dz=", "push button" );
runtime.addCustomToolButton( "admesC", "speed=" + vspeed, "push button" );

main();
/*
var xx = new Array(2);
var yy = new Array(2);
var zz = new Array(2);

xx[0] = bb.max.x;
xx[1] = bb.min.x;
yy[0] = bb.max.y;
yy[1] = bb.min.y;
zz[0] = bb.max.z;
zz[1] = bb.min.z;
for (var i=0;i<2;i++){
for (var j=0;j<2;j++){
for (var k=0;k<2;k++){
createlght( xx[i], yy[j], zz[k] ,i,j,k )
}
}
}
function createlght(x,y,z,i,j,k){
	var lght = scene.createLight();
	lght.transform.translateInPlace( new Vector3( x,y,z ) );
	lght.attenuationA = 0.01;
	lght.attenuationB = 0.01;
	lght.attenuationC = 0.01;
	lght.type = "point";
	lght.brightness = 1.0;
	lght.color.set( ( 0.5 + i / 4.0 ) ,( 0.6 + j / 4.0) ,( 0.7 + k / 4.0 ))
	lght.attenuationType = "abc";
	lght.innerRadius = 0;
	lght.outerRadius = diag.length / 2;
}
*/

